/**
 * 注入API，主要用于各产品特色的公共API注入，如登出手机银行
 */
import Vue from 'vue'
import bocutil from '@boc/mfe/bocutil'
import axios from '@boc/mfe/axios'

Vue.use(bocutil)
export default {
  install: function (Vue, options) {
    /**
     * 应用于函数错误回调的登出
     * @function
     * @name logout
     */
    Vue.bocutil.logout = function (alertInstance) {
      var url = window.location.href
      // var pos = url.indexOf('bocmaent')
      // window.location.href = url.substring(0, pos) + 'bocmaent/accountsOpen/index.html#/login'
      var pos = url.indexOf('accountsOpen')
      window.location.href = url.substring(0, pos) + 'accountsOpen/index.html#/login'
      // var pos = url.indexOf('accountsOpen')
      // // window.location.href = url.substring(0, pos) + 'accountsOpen/index.html#/login'
      // window.location.href = 'http://scp.dms.bocoa.com/Pages/index.aspx#'
    }
    /**
     * 主动退出
     * @memberof Common
     * @function
     * @name logout
     * @param (Json) data - 登出时的提示消息
     * @example Common.logout({message:"您确认要退出吗？"});
     */
    Vue.bocutil.logoutToApp = function () {
      var urlParams = Vue.bocutil.urlparams
      if (Vue.bocutil.terminal.weixin || urlParams.dev == 'weixin') {
        try {
          Request('Logout').then(function () {
            //this.$router.push(redirect)
              //window.location.href = redirect

            //     loginPath = window.location.protocol + '//' + window.location.host +
            //     window.location.pathname.replace('indexWX.html', '') + 'Framework/index.html?entrance=WeiXin_Login'
            //     + '&appid=' + urlParams.appid
            //     // +'&code='+urlParams.code
            //     // +'&state='+urlParams.state
            //     // +'&dev='+urlParams.dev
            //     // +'&target='+urlParams.target
            //     // +'&openid='+urlParams.openid
            //     // +'&debug='+urlParams.debug
            //     + '&redirect='
            //     // loginPath = window.location.href.split('#')[0] + '#/login' +'?dev=weixin'+ '&appid='+urlParams.appid+ '&code='+
            //     // urlParams.code + '&redirect='
            //     if (redirect) {
            //       redirect = redirect + '&appid=' + urlParams.appid
            //       + '&code=' + urlParams.code
            //       + '&state=' + urlParams.state
            //       if (urlParams.openid) {
            //         redirect = redirect + '&openid=' + urlParams.openid
            //       }
            //       if (urlParams.debug) {
            //         redirect = redirect + '&debug=' + urlParams.debug
            //       }
            //       loginPath += encodeURIComponent(redirect)
            //
            //       // loginPath = 'https://open.weixin.qq.com/connect/oauth2/authorize?appid=' + urlParams.appid + '&redirect_uri=' + encodeURIComponent(redirect) + '&response_type=code&scope=snsapi_base&state=1#wechat_redirect'
            //       // loginPath += encodeURIComponent(redirect)
            //}
            //     else loginPath += encodeURIComponent(window.location.href)
            //     // alert('测试appid'+JSON.stringify(loginPath))
            //     history.replaceState(urlParams, null, loginPath)//2017.11.6 新增by@gw：706贷款管理登录前微信端点击登陆手机银行，点击返回，appid不能为空报错
            //     window.location.href = loginPath
            //   })
          })
        } catch (e) {
          console.log('走catch')
          // alert('走catch')
        }
      } else {
        var cplugins = Vue.prototype.c_plugins
        try {
          cplugins && cplugins.commonBridge.goToLogin(function (data) {
          }, function (err) {
          }, {});
        } catch (e) {
        }
      }
    }

    //获取用户信息
    Vue.bocutil.getCustomerMessage = function (success, fail) {
      // var res = {}
      Request('PsnCommonQueryOprLoginInfo').then(function (res) {
        if (!res) {
          Vue.bocutil.log.error("后台异常，返回空报文");
          return fail({error: "后台异常，返回空报文"});
          // throw {type: 'AppError', message: '返回异常', code: 'H5000003'}
        }

        var replaceNull = function (jsn) {
          if (jsn) {
            for (var p in jsn) {
              if (jsn[p] == null)
                jsn[p] = "";
              if (typeof jsn[p] == 'object') {
                jsn[p] = this.replaceNull(jsn[p]);
              }
            }
          }
          return jsn
        }
        //正常返回报文时
        // console.log('res' + res)
        if (!res._isException_) {
          var rst = res.result;
          if (rst != null && rst != undefined) {
            //将报文中的null处理后返回
            // return replaceNull(rst);
            rst = replaceNull(rst)
            if (rst.identityType != null && rst.identityType != undefined) {
              rst.identityType += ""
              rst.identityType = Vue.bocutil.getConstantValue(rst.identityType, 'ToidentityType')
            }
            return success(rst)
          }
          // return rst;
          return success(rst)
        }
        else
          return fail({error: res.message});
      })
    }
    //获取登陆状态
    Vue.bocutil.hasLogIn = function (success, fail) {
      // if(Vue.bocutil.terminal.weixin || Vue.bocutil.urlparams.dev == 'weixin'){
      Request('PsnCommonQueryOprLoginInfo').then(function (res) {
        // alert(JSON.stringify('HL'+res))
        if (!res) {
          Vue.bocutil.log.error("后台异常，返回空报文");
          return fail({error: "后台异常，返回空报文"});
        }
        //正常返回报文时
        if (!res._isException_) {
          return success({logFlag: '1'})
        }
        else {
          var errorMap = {
            "validation.session_invalid": "不同电脑登录",
            "role.invalid_user": "会话超时",
            "validation.resubmit_same_session": "同一台电脑登录",
            "QA.authenticate.limit": "问答错误次数达到最大限制",
            "smc.token.lock": "手机验证码验证失败!",
            "smc.token.false.lock": "手机验证码验证失败!",
            "smc.token.true.lock": "令牌被锁!",
            "otp.token.lock": "由于您连续试图用错误的 动态口令 进入系统，您的操作权利已被系统撤消，请立即与中国银行联系!",
            "otp.token.false.lock": "您试图用错误的动态口令进入系统，您当日的操作权利已被取消，次日自动恢复，如有需要请与中行联系!",
            "otp.token.true.lock": "令牌已锁，请到柜台解锁!",
            "conversationMap.null": "您的会话已失效，请重新操作!",
            // "conversation.null": "您的会话已失效，请重新操作!"
          };
          if (res && res.code && res.code in errorMap) {
            return success({logFlag: '0'})
          } else {
            //接口如果请求不通，该如何处理？仍旧return 0
            return fail({error: res.message});
          }
        }
      })
      // }
      // else{
      // var timer = setInterval(function () {
      //     if (this.c_plugins) {
      //         clearInterval(timer)
      //         this.c_plugins.commonBridge.hasLogIn(function (res) { // 获取登录状态
      //             return success(res)
      //         }, function (err) {
      //             return fail(err);
      //         }, {})
      //     }
      // }, 100)

      //     this.c_plugins.commonBridge.hasLogIn(function (res) {
      //         return success(res)
      //     }, function (err) {
      //         return fail(err);
      //     }, {})

      // }
    }
    //获取登陆状态
    Vue.bocutil.download_WX = function () {
      // alert('进入下载')
      if (Vue.bocutil.terminal.weixin) {
        // alert('进入微信下载')
        var path = ""
        var urlParams = Vue.bocutil.urlparams
        path = window.location.protocol + '//' + window.location.host +
        window.location.pathname + '#/loanIndex?'
        + 'appid=' + urlParams.appid
        + '&code=' + urlParams.code
        + '&state=' + urlParams.state
        + '&dev=' + urlParams.dev
        // +'&openid='+urlParams.openid
        // +'&debug='+urlParams.debug
        // +'&demo='+urlParams.demo
        + '&target=myloan'
        // history.replaceState(path)
        history.replaceState(urlParams, null, path)

        if (Vue.bocutil.terminal.ios) {
          // alert('下载ios'+JSON.stringify(path))
          // window.location.href = #/loanIndex?appid=wxc721f6dd62c9636d&openid=ogw_Ot-weYZtCEHDVzEh6ic9aiHY&code=123123&dev=weixin&demo=t&target=moreloan
          document.location = 'https://itunes.apple.com/cn/app/zhong-guo-yin-xing-shou-ji/id399608199?mt=8';
          // document.getElementById('JweixinTip').style.display = 'block';
          // document.getElementById('JweixinTip').onclick = function () {
          //     this.style.display = 'none';
          // }
        }
        // else if (Vue.bocutil.terminal.android) {
        else {
          // alert('下载android'+JSON.stringify(path))
          document.location = 'http://app.qq.com/#id=detail&appid=100757597';
        }
      }
      else if (Vue.bocutil.terminal.ios) {
        // alert('进入ios下载,已错误')
        document.location = 'https://itunes.apple.com/cn/app/zhong-guo-yin-xing-shou-ji/id399608199?mt=8';
      }
      else if (Vue.bocutil.terminal.android) {
        // alert('进入android下载,已错误')
        document.location = 'boc://com.chinamworld.bocmbci/startWith';
        setInterval(function () {
          document.location = 'http://pic.bankofchina.com/bocappd/mbs/bocmbci_a.apk';
          //此处如果执行则表示没有app
        }, 200)

      }
    }

    //请求接口，返回数据用于判定状态与获取数据
    function Request(method) {
      var param = {
        method: method,
        params: {},
        url: '/BII/_bfwajax.do'
      }
      var _data = Vue.http.bfw.getPostParam(param)
      var config = {
        dataType: 'json',
        timeout: 180000,
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/x-www-form-urlencoded',
          "bfw-ctrl": "json"
        }, // 合并报文头信息
        method: 'POST',
        url: '/BII/_bfwajax.do?_locale=zh_CN', //WBA
        params: {json: _data}
      }
      if (Vue.bocutil.urlparams.demo) {
        config.method = 'GET'
        config.url = "/static/data/" + method + ".json";
      }
      return axios(config).then(function (res) {
        console.log('axios' + res)
        // return JSON.parse(res.request.responseText)
        return res.data
      })
      // return result
    }
    // 微信分享时用于匹配相应的appid参数
    Vue.bocutil.getAppid = function () {
      var url = window.location.href
      // 生产环境appid
      var appid = 'wx567af860fd4db040'
      // T003 appid
      var appidUat = 'wxc721f6dd62c9636d'
      // T004 appid
      var appidUat2 = 'wxbd61ac3eba9dc99d'
      if (url.indexOf('bocuat.javascriptchina.com') > -1) {
        return appidUat
      } else if (url.indexOf('bocuat2.javascriptchina.com') > -1) {
        return appidUat2
      } else {
        return appid
      }
    }

    // 微信分享设置appid参数
    Vue.bocutil.setAppid = function (appid) {
      Vue.bocutil.urlparams.appid = appid
    }
    /**
     * 分享页面用wfss
     */
    Vue.http && (Vue.http.wfss = function (service, params) {
      var url = service.url + service.method
      //发送ajax请求
      return Vue.http.jsonp({
        url: url,
        jsonpCallback: 'callback' + parseInt(Math.random() * 0xfff),   //后台接口输出的方法调用，需与本出保持一致
        params: params,
        beforeSend: function () {
        }
      })
    })
  }
}
